import os
import h5py
import numpy as np
import pandas as pd
import datetime

# test read the h5 file
# with h5py.File(f"./data/h5_format/pemsm_data.h5", 'r') as hf:
#     data_speed = hf['data'][:]
#     print(data_speed.shape)
# with h5py.File(f"./data/h5_format/pemsd8_data.h5", 'r') as hf:
#     data_speed = hf['data'][:]
#     print(data_speed.shape)
# with h5py.File(f"./data/h5_format/pemsbay_data.h5", 'r') as hf:
#     data_speed = hf['data'][:]
#     print(data_speed.shape)


# # transform the weekday csv data to the .h5 format
def data_prepare(file_path, day_slot=288):  # 适用于PEMSBAY，工作日45天，
    data_seq = pd.read_csv(file_path, header=None).values.astype(float)
    data_seq_flow = np.array(data_seq)
    weekend_index = []
    for i in range(1, 9):
        weekend_index.append(7 * i - 2)
        weekend_index.append(7 * i - 1)
    day_sum = int(data_seq_flow.shape[0] / day_slot)
    data_seq_flow_weekend = pd.DataFrame()
    data_seq_flow_weekday = pd.DataFrame()
    for i in range(day_sum):
        data_seq_flow_day = data_seq_flow[day_slot * i: day_slot * (i + 1), :]
        if i in weekend_index:
            data_seq_flow_weekend = pd.concat([data_seq_flow_weekend, pd.DataFrame(data_seq_flow_day)], axis=0)
        else:
            data_seq_flow_weekday = pd.concat([data_seq_flow_weekday, pd.DataFrame(data_seq_flow_day)], axis=0)
    df = pd.DataFrame(data_seq_flow_weekday).reset_index(drop = True)
    return df


def data_prepare_pems08(file_path, day_slot=288):  # 2016年7月至8月的数据，共62天数据,根据日历剔除周末,44天
    data_seq = pd.read_csv(file_path, header=None).values.astype(float)
    data_seq_flow = np.array(data_seq)
    weekend_index = []
    for i in range(1, 9):
        weekend_index.append(7 * i + 1)
        weekend_index.append(7 * i + 2)
    weekend_index.append(1)  # 将第一周的数据分开存放
    weekend_index.append(2)
    day_sum = int(data_seq_flow.shape[0] / day_slot)
    data_seq_flow_weekend = pd.DataFrame()
    data_seq_flow_weekday = pd.DataFrame()
    for i in range(day_sum):
        data_seq_flow_day = data_seq_flow[day_slot * i: day_slot * (i + 1), :]
        if i in weekend_index:
            data_seq_flow_weekend = pd.concat([data_seq_flow_weekend, pd.DataFrame(data_seq_flow_day)], axis=0)
        else:
            data_seq_flow_weekday = pd.concat([data_seq_flow_weekday, pd.DataFrame(data_seq_flow_day)], axis=0)
    df = pd.DataFrame(data_seq_flow_weekday).reset_index(drop = True)
    return df
#
data_file_path_pemsm = "./data/PeMS-M/V_228.csv"
data_file_path_pemsbay = "./data/pemsbay/Speed_325.csv"
data_file_path_pemsd8 = "./data/PEMSD8/Speed_170.csv"
data_path = []
data_path.append(data_file_path_pemsm)
data_path.append(data_file_path_pemsbay)
data_path.append(data_file_path_pemsd8)


strTime = '2017-03-06 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
index = []
temp = startTime
# 第一周
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))

# 第二周
strTime = '2017-03-13 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))

# 第三周
strTime = '2017-03-20 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))

#
# 第四周
strTime = '2017-03-27 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
#
#
# 第五周
strTime = '2017-04-03 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
#
#
# 第六周
strTime = '2017-04-10 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
#
# 第七周
strTime = '2017-04-17 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
#
# 第八周
strTime = '2017-04-24 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
#
# 第九周
strTime = '2017-05-01 00:00:00'
startTime = datetime.datetime.strptime(strTime, "%Y-%m-%d %H:%M:%S")
temp = startTime
for i in range(1, 5*288):
    index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
    temp = temp + datetime.timedelta(minutes=5)
index.append(temp.strftime("%Y-%m-%d %H:%M:%S"))
print(index)
print(len(index))
date_index = pd.to_datetime(index)
data_seq = data_prepare(data_path[1])
print(data_seq)
df_pemsbay = data_seq.set_index(date_index)
print(df_pemsbay)
print(df_pemsbay.shape)
df_pemsbay.to_hdf("./data/h5_format/pemsbay_data.h5", key='df_pemsbay')
# data_path = []
# data_file_path_pemsm = "./data/PeMS-M/V_228.csv"
# data_file_path_pemsbay = "./data/pemsbay/Speed_325.csv"
# data_file_path_pemsd8 = "./data/PEMSD8/Speed_170.csv"
#
# data_path.append(data_file_path_pemsm)
# data_path.append(data_file_path_pemsbay)
# data_path.append(data_file_path_pemsd8)
# for i in range(len(data_path)):
#     data_seq = pd.DataFrame()
#     if i == 0:
#         data_seq = pd.read_csv(data_path[i], header=None).values.astype(float)
#         print(data_seq.shape)
#     elif i == 1:
#         data_seq = data_prepare(data_path[i])
#         print(data_seq.shape)
#     else:
#         data_seq = data_prepare_pems08(data_path[i])
#         print(data_seq.shape)
#     data_seq_speed = np.array(data_seq)
#     f = h5py.File(str(i) + ".h5", 'w')
#     f['data'] = data_seq_speed
#     f.close()