import random
import torch
import torch.nn as nn
import numpy as np
from sklearn.preprocessing import StandardScaler
from model_hyper_graph_transformer import HyperGraphTransformerWeight
from utils2 import construct_pemsbay_hyper_graph_laplacian, construct_pemsbay_line_graph_from_hyper_graph
from utils import load_data, data_transform, evaluate_model_hyper_graph_transformer_weight, evaluate_metric_hyper_graph_transformer
from torch.utils.data import DataLoader, TensorDataset
torch.manual_seed(2333)
torch.cuda.manual_seed(2333)
np.random.seed(2333)
random.seed(2333)
torch.backends.cudnn.deterministic = True
device = torch.device("cuda") if torch.cuda.is_available() else torch.device("cpu")
data_path = "./data/pemsbay/Speed_325.csv"
save_path = "./pretrain_model/pemsbay/model_pemsbay_HyperGCN_12_weight.pt"
day_slot = 288
n_train, n_val, n_test = 35, 5, 5
batch_size = 50
epochs = 50
lr = 1e-3
n_his = 12
n_pred = 12
n_cluster = 64
output_dim = 8
input_feature = 1
embedding_size = 64
conv_output = 8
n_node = 325
hyper_graph_lap_np = np.load("./data/adj_text_format/hyper_graph_lap_pemsbay.npy")
hyper_graph_lap = torch.Tensor(hyper_graph_lap_np).to(device)
line_graph_lap_np = np.load("./data/adj_text_format/line_graph_lap_pemsbay.npy")
line_graph_lap = torch.Tensor(line_graph_lap_np).to(device)
hidden_size = conv_output * n_node
filter_size = 512
dropout_rate = 0
n_layers = 6
target_len = n_pred
train, val, test = load_data(data_path, n_train * day_slot, n_val * day_slot)  # 2017年3月6日到4月30日 ,除去周末，40天
scaler = StandardScaler()
train = scaler.fit_transform(train)
val = scaler.transform(val)
test = scaler.transform(test)
x_train, y_train = data_transform(train, n_his, n_pred, day_slot, device)
x_val, y_val = data_transform(val, n_his, n_pred, day_slot, device)
x_test, y_test = data_transform(test, n_his, n_pred, day_slot, device)
train_data = TensorDataset(x_train, y_train)
train_iter = DataLoader(train_data, batch_size, shuffle=True)
val_data = TensorDataset(x_val, y_val)
val_iter = DataLoader(val_data, batch_size)
test_data = TensorDataset(x_test, y_test)
test_iter = DataLoader(test_data, batch_size)

loss = nn.MSELoss()
# model = HyperGraphTransformerWeight(input_feature=input_feature, embedding_size=embedding_size, conv_output_size=conv_output,
#                               n_node=n_node, hyper_graph_lap=hyper_graph_lap, line_graph_lap=line_graph_lap,
#                               hidden_size=hidden_size, filter_size=filter_size, dropout_rate=dropout_rate,
#                               n_layers=n_layers, target_len=target_len).to(device)
# optimizer = torch.optim.Adam(model.parameters(), lr=lr)
# scheduler = torch.optim.lr_scheduler.StepLR(optimizer, step_size=5, gamma=0.7)
# min_val_loss = np.inf
# final_weight = 0
# for epoch in range(1, epochs + 1):
#     l_sum, n = 0.0, 0
#     model.train()
#     for x, y in train_iter:
#         targets = y
#         model_outputs, weight_output = model(x, y)
#         final_weight = weight_output
#         l_loss = loss(model_outputs,targets)
#         optimizer.zero_grad()
#         l_loss.backward()
#         optimizer.step()
#         l_sum += l_loss.item() * y.shape[0]
#         n += y.shape[0]
#     scheduler.step()
#     val_loss = evaluate_model_hyper_graph_transformer_weight(model, loss, val_iter)
#     if epoch == 1:
#         print("1")
#         temp_save_path = "./pretrain_model/pemsbay/model_pemsbay_HyperGCN_12_weight_epoch_1.pt"
#         torch.save(model.state_dict(), temp_save_path)
#         epoch_weight = final_weight.cpu().numpy()
#         np.save("./pretrain_model/pemsbay/epoch_1_weight", np.array(epoch_weight))
#     if epoch == 15:
#         temp_save_path = "./pretrain_model/pemsbay/model_pemsbay_HyperGCN_12_weight_epoch_15.pt"
#         torch.save(model.state_dict(), temp_save_path)
#         epoch_weight = final_weight.cpu().numpy()
#         np.save("./pretrain_model/pemsbay/epoch_15_weight", np.array(epoch_weight))
#     if epoch == 30:
#         temp_save_path = "./pretrain_model/pemsbay/model_pemsbay_HyperGCN_12_weight_epoch_30.pt"
#         torch.save(model.state_dict(), temp_save_path)
#         epoch_weight = final_weight.cpu().numpy()
#         np.save("./pretrain_model/pemsbay/epoch_30_weight", np.array(epoch_weight))
#     if val_loss < min_val_loss:
#         min_val_loss = val_loss
#         torch.save(model.state_dict(), save_path)
#     print("epoch", epoch, ", train loss:", l_sum / n, ", validation loss:", val_loss)
# final_weight = final_weight.cpu().numpy()
# np.save("./pretrain_model/pemsbay/final_weight", np.array(final_weight))
# temp_save_path = "./pretrain_model/pemsbay/model_pemsbay_HyperGCN_12_weight_epoch_1.pt"

# best_model = HyperGraphTransformerWeight(input_feature=input_feature, embedding_size=embedding_size, conv_output_size=conv_output,
#                               n_node=n_node, hyper_graph_lap=hyper_graph_lap, line_graph_lap=line_graph_lap,
#                               hidden_size=hidden_size, filter_size=filter_size, dropout_rate=dropout_rate,
#                               n_layers=n_layers, target_len=target_len).to(device)
# best_model.load_state_dict(torch.load(save_path))

# MAE, MAPE,RMSE = evaluate_metric_hyper_graph_transformer(best_model, test_iter, scaler)
# print("HyperGraph_pemsbay_15min")
# print("test metric:", "\nMAE:", MAE,"\nMAPE:", MAPE, ", RMSE:", RMSE)
'''torch.Size([325, 325])
1
epoch 1 , train loss: 0.7100779904140218 , validation loss: 0.5530710859673211
epoch 2 , train loss: 0.4393030818219449 , validation loss: 0.48651112967228355
epoch 3 , train loss: 0.3460393714738461 , validation loss: 0.42707222110827836
epoch 4 , train loss: 0.291628255567243 , validation loss: 0.3583717066808982
epoch 5 , train loss: 0.22201958735737085 , validation loss: 0.3115721422666459
epoch 6 , train loss: 0.16472567767151153 , validation loss: 0.24482482188110727
epoch 7 , train loss: 0.12611553376166745 , validation loss: 0.20335980690013883
epoch 8 , train loss: 0.09525793999456031 , validation loss: 0.16485925486926087
epoch 9 , train loss: 0.07410856326511514 , validation loss: 0.1438346029008636
epoch 10 , train loss: 0.05865688438577127 , validation loss: 0.12936387563059903
epoch 11 , train loss: 0.044191403566709295 , validation loss: 0.11260375517812929
epoch 12 , train loss: 0.03664388776150165 , validation loss: 0.10291503652929641
epoch 13 , train loss: 0.03159777635616683 , validation loss: 0.09183018230510664
epoch 14 , train loss: 0.026974094987222866 , validation loss: 0.08284791049430248
epoch 15 , train loss: 0.023787412800617688 , validation loss: 0.07444852832741038
epoch 16 , train loss: 0.02003895477209964 , validation loss: 0.06873411371882482
epoch 17 , train loss: 0.01837829512302704 , validation loss: 0.06518545017563979
epoch 18 , train loss: 0.017263563589548402 , validation loss: 0.06073371339738574
epoch 19 , train loss: 0.01649881969011388 , validation loss: 0.05801866514255993
epoch 20 , train loss: 0.015522609135342876 , validation loss: 0.05691232886558012
epoch 21 , train loss: 0.014000770176384174 , validation loss: 0.054024865051596496
epoch 22 , train loss: 0.013387570592497629 , validation loss: 0.053693281579744644
epoch 23 , train loss: 0.012969389583103206 , validation loss: 0.052032154773239206
epoch 24 , train loss: 0.012521519025737888 , validation loss: 0.049878896420049966
epoch 25 , train loss: 0.012264435410886721 , validation loss: 0.050121746468397566
epoch 26 , train loss: 0.011292821542571262 , validation loss: 0.047649952047258075
epoch 27 , train loss: 0.010927301500289416 , validation loss: 0.04697366046324939
epoch 28 , train loss: 0.010705732714423821 , validation loss: 0.04615970955388523
epoch 29 , train loss: 0.010529962284046523 , validation loss: 0.04649399523452025
epoch 30 , train loss: 0.010304469743897406 , validation loss: 0.04508790188733141
epoch 31 , train loss: 0.0097201438096325 , validation loss: 0.04479586659226024
epoch 32 , train loss: 0.009506207489079169 , validation loss: 0.04447643151544528
epoch 33 , train loss: 0.009352420005334898 , validation loss: 0.04445119034822999
epoch 34 , train loss: 0.009266685417603678 , validation loss: 0.04347912788760152
epoch 35 , train loss: 0.009129083324655066 , validation loss: 0.04348337068324448
epoch 36 , train loss: 0.008709889863173788 , validation loss: 0.04275654212798788
epoch 37 , train loss: 0.008593748451110557 , validation loss: 0.04241489543422226
epoch 38 , train loss: 0.008489821349979923 , validation loss: 0.042683662252142894
epoch 39 , train loss: 0.008409537754649733 , validation loss: 0.04253891330556381
epoch 40 , train loss: 0.008313676269943553 , validation loss: 0.04284238904123855
epoch 41 , train loss: 0.008022411914042646 , validation loss: 0.04252378787226527
epoch 42 , train loss: 0.00794082703972674 , validation loss: 0.04220040826412833
epoch 43 , train loss: 0.00786210375669958 , validation loss: 0.042292229704566565
epoch 44 , train loss: 0.007816724918374365 , validation loss: 0.04170654939554977
epoch 45 , train loss: 0.007758951233177367 , validation loss: 0.042069326430199935
epoch 46 , train loss: 0.007545334683778445 , validation loss: 0.04183547103563397
epoch 47 , train loss: 0.00747999076116712 , validation loss: 0.04160068530799601
epoch 48 , train loss: 0.007435581860963791 , validation loss: 0.041754524981899035
epoch 49 , train loss: 0.00738539937765395 , validation loss: 0.041761862380995045
epoch 50 , train loss: 0.00732324415664997 , validation loss: 0.0419545795604292'''