import random
import torch
import torch.nn as nn
import numpy as np
from sklearn.preprocessing import StandardScaler
from utils import load_data, data_transform, evaluate_model_hyper_graph_transformer_weight, evaluate_metric_hyper_graph_transformer
from utils2 import construct_pemsbay_hyper_graph_laplacian, construct_pemsbay_line_graph_from_hyper_graph, construct_pemsbay_graph_normalized_adj
from torch.utils.data import DataLoader, TensorDataset
from model_hypergraph_lstm import LGraphTransformerWeight
torch.manual_seed(2333)
torch.cuda.manual_seed(2333)
np.random.seed(2333)
random.seed(2333)
torch.backends.cudnn.deterministic = True
device = torch.device("cuda") if torch.cuda.is_available() else torch.device("cpu")
data_path = "./data/pemsbay/Speed_325.csv"
save_path_raw = "./pretrain_model/pemsbay/model_pemsbay_LGCN_pre"
day_slot = 288
n_train, n_val, n_test = 35, 5, 5
batch_size = 50
epochs = 50
lr = 1e-3
n_his = 12
n_preds = [2, 3, 4]
n_cluster = 128
output_dim = 8
input_feature = 1
embedding_size = 64
conv_output = 8  # 1 for Transformer only
n_node = 325
hyper_graph_lap = construct_pemsbay_hyper_graph_laplacian(n_clusters=n_cluster)
line_graph_lap = construct_pemsbay_line_graph_from_hyper_graph(n_clusters=n_cluster)
graph_lap = construct_pemsbay_graph_normalized_adj()
hidden_size = conv_output * n_node
filter_size = 512
dropout_rate = 0
n_layers = 6
train, val, test = load_data(data_path, n_train * day_slot, n_val * day_slot)
print(np.any(train == 0))
print(np.any(val == 0))
print(np.any(test == 0))
# for n_pred in n_preds:
#     save_path = save_path_raw + str(n_pred) + ".pt"
#     print(save_path)
#     train, val, test = load_data(data_path, n_train * day_slot, n_val * day_slot)  # 2012年4月2日到5月31日,除去周末，44天
#     scaler = StandardScaler()
#     train = scaler.fit_transform(train)
#     val = scaler.transform(val)
#     test = scaler.transform(test)
#     x_train, y_train = data_transform(train, n_his, n_pred, day_slot, device)
#     x_val, y_val = data_transform(val, n_his, n_pred, day_slot, device)
#     x_test, y_test = data_transform(test, n_his, n_pred, day_slot, device)
#     train_data = TensorDataset(x_train, y_train)
#     train_iter = DataLoader(train_data, batch_size, shuffle=True)
#     val_data = TensorDataset(x_val, y_val)
#     val_iter = DataLoader(val_data, batch_size)
#     test_data = TensorDataset(x_test, y_test)
#     test_iter = DataLoader(test_data, batch_size)
#
#     loss = nn.MSELoss()
#     # model = LGraphTransformerWeight(input_feature=input_feature, embedding_size=embedding_size, conv_output_size=conv_output,
#     #                               n_node=n_node, line_graph_lap=line_graph_lap,
#     #                               output_size=n_pred).to(device)
#     # optimizer = torch.optim.Adam(model.parameters(), lr=lr)
#     # scheduler = torch.optim.lr_scheduler.StepLR(optimizer, step_size=5, gamma=0.7)
#     # min_val_loss = np.inf
#     # for epoch in range(1, epochs + 1):
#     #     l_sum, n = 0.0, 0
#     #     model.train()
#     #     for x, y in train_iter:
#     #         model_outputs, enc_weight_output = model(x)
#     #         final_weight = enc_weight_output
#     #         l_loss = loss(model_outputs, y)
#     #         optimizer.zero_grad()
#     #         l_loss.backward()
#     #         optimizer.step()
#     #         l_sum += l_loss.item() * y.shape[0]
#     #         n += y.shape[0]
#     #     scheduler.step()
#     #     val_loss = evaluate_model_hyper_graph_transformer_weight(model, loss, val_iter)
#     #     if val_loss < min_val_loss:
#     #         min_val_loss = val_loss
#     #         torch.save(model.state_dict(), save_path)
#     #     print("epoch", epoch, ", train loss:", l_sum / n, ", validation loss:", val_loss)
#     best_model = LGraphTransformerWeight(input_feature=input_feature, embedding_size=embedding_size, conv_output_size=conv_output,
#                                   n_node=n_node, line_graph_lap=line_graph_lap,
#                                   output_size=n_pred).to(device)
#     best_model.load_state_dict(torch.load(save_path))
#     MAE, MAPE,RMSE = evaluate_metric_hyper_graph_transformer(best_model, test_iter, scaler)
#     print("LGraph_pemsbay_15min")
#     print("test metric:", "\nMAE:", MAE,"\nMAPE:", MAPE, ", RMSE:", RMSE)


# best_model = LGraphTransformer(input_feature=input_feature, embedding_size=embedding_size, conv_output_size=conv_output,
#                               n_node=n_node, line_graph_lap=line_graph_lap,
#                               hidden_size=hidden_size, filter_size=filter_size, dropout_rate=dropout_rate,
#                               n_layers=n_layers, target_len=target_len).to(device)
# best_model.load_state_dict(torch.load(save_path))
# MAE, MAPE,RMSE = evaluate_metric_hyper_graph_transformer(best_model, test_iter, scaler)
# print("LGraph_pemsbay_15min")
# print("test metric:", "\nMAE:", MAE,"\nMAPE:", MAPE, ", RMSE:", RMSE)
'''./pretrain_model/pemsbay/model_pemsbay_LGCN_pre2.pt
epoch 1 , train loss: 0.3235403033587528 , validation loss: 0.14377016114500643
epoch 2 , train loss: 0.10626056967974125 , validation loss: 0.11110512949868338
epoch 3 , train loss: 0.09457872503247594 , validation loss: 0.10677088360084956
epoch 4 , train loss: 0.09188137939417872 , validation loss: 0.10472908426546738
epoch 5 , train loss: 0.0896099558307529 , validation loss: 0.09997294547120836
epoch 6 , train loss: 0.08599447005608592 , validation loss: 0.10200121880991411
epoch 7 , train loss: 0.08550356079623969 , validation loss: 0.09708521925784566
epoch 8 , train loss: 0.08469345440577802 , validation loss: 0.0948340262662765
epoch 9 , train loss: 0.08155322652778353 , validation loss: 0.0926728032487675
epoch 10 , train loss: 0.08068077598115063 , validation loss: 0.092914146929741
epoch 11 , train loss: 0.07963407433228954 , validation loss: 0.091011855415126
epoch 12 , train loss: 0.07931131719540584 , validation loss: 0.0914526280443795
epoch 13 , train loss: 0.07902402167321487 , validation loss: 0.09063018889861162
epoch 14 , train loss: 0.07888664002755587 , validation loss: 0.09239943547387454
epoch 15 , train loss: 0.07864479586386036 , validation loss: 0.0900695481037643
epoch 16 , train loss: 0.07797959768589956 , validation loss: 0.08900201259712232
epoch 17 , train loss: 0.07783749712192667 , validation loss: 0.08920965252067194
epoch 18 , train loss: 0.07749569888924424 , validation loss: 0.08934362895014292
epoch 19 , train loss: 0.07759379260662087 , validation loss: 0.0888416191588209
epoch 20 , train loss: 0.07736501366133791 , validation loss: 0.09085046283430853
epoch 21 , train loss: 0.07690159032043184 , validation loss: 0.08799854752671507
epoch 22 , train loss: 0.07680940374907602 , validation loss: 0.08810198277831095
epoch 23 , train loss: 0.07656104961192207 , validation loss: 0.08876513969427306
epoch 24 , train loss: 0.07665031054181758 , validation loss: 0.08784501952973266
epoch 25 , train loss: 0.0766456189100694 , validation loss: 0.09039806622823114
epoch 26 , train loss: 0.07615216353716496 , validation loss: 0.08780386762536259
epoch 27 , train loss: 0.07609017259151525 , validation loss: 0.08760476308223708
epoch 28 , train loss: 0.0759670008887909 , validation loss: 0.08743770270840785
epoch 29 , train loss: 0.07604187567145754 , validation loss: 0.08729919696624662
epoch 30 , train loss: 0.07599421936373264 , validation loss: 0.08714619009300731
epoch 31 , train loss: 0.07565771582327468 , validation loss: 0.08681368194227743
epoch 32 , train loss: 0.07560733957290883 , validation loss: 0.08750655057546232
epoch 33 , train loss: 0.07557781765217826 , validation loss: 0.0871021357844887
epoch 34 , train loss: 0.07554009605200974 , validation loss: 0.08690153549396779
epoch 35 , train loss: 0.07557995105992099 , validation loss: 0.08691784105957229
epoch 36 , train loss: 0.07526467982586597 , validation loss: 0.08691055472251619
epoch 37 , train loss: 0.0751977359055797 , validation loss: 0.08706762433397117
epoch 38 , train loss: 0.07523159503114517 , validation loss: 0.08689699049104155
epoch 39 , train loss: 0.07529432118403909 , validation loss: 0.0868001306074155
epoch 40 , train loss: 0.0751824343771916 , validation loss: 0.08663126788365277
epoch 41 , train loss: 0.07501230102960968 , validation loss: 0.08648832925923261
epoch 42 , train loss: 0.07501822743135893 , validation loss: 0.08676255534329612
epoch 43 , train loss: 0.07498704652041553 , validation loss: 0.08654708864948212
epoch 44 , train loss: 0.0749615463897014 , validation loss: 0.08680815186285107
epoch 45 , train loss: 0.07499941360866778 , validation loss: 0.08649145585923146
epoch 46 , train loss: 0.07484037284499875 , validation loss: 0.086523989574178
epoch 47 , train loss: 0.07479624553985519 , validation loss: 0.08632809160275835
epoch 48 , train loss: 0.07479041672251854 , validation loss: 0.08628315034537717
epoch 49 , train loss: 0.07479511222929672 , validation loss: 0.08625445861450257
epoch 50 , train loss: 0.07475211832652995 , validation loss: 0.08624487177400268
./pretrain_model/pemsbay/model_pemsbay_LGCN_pre3.pt
epoch 1 , train loss: 0.3688568677637795 , validation loss: 0.20104677363959889
epoch 2 , train loss: 0.14412777346760017 , validation loss: 0.17458123907429934
epoch 3 , train loss: 0.13197117650203308 , validation loss: 0.15235868582076065
epoch 4 , train loss: 0.12572382755485262 , validation loss: 0.14787443964361105
epoch 5 , train loss: 0.12274975108266768 , validation loss: 0.14098509628119904
epoch 6 , train loss: 0.11742157028760837 , validation loss: 0.13501028503139503
epoch 7 , train loss: 0.11645692280186594 , validation loss: 0.13297515499689438
epoch 8 , train loss: 0.11475566340741501 , validation loss: 0.1339558058480342
epoch 9 , train loss: 0.11336529618282425 , validation loss: 0.1304781112247749
epoch 10 , train loss: 0.11314094235866562 , validation loss: 0.1303412505254304
epoch 11 , train loss: 0.11116176531479185 , validation loss: 0.12774700510406817
epoch 12 , train loss: 0.11096229414341649 , validation loss: 0.12825057171005833
epoch 13 , train loss: 0.11025708290703876 , validation loss: 0.1287630601040493
epoch 14 , train loss: 0.11017523936163437 , validation loss: 0.12748157207919877
epoch 15 , train loss: 0.10992932936253348 , validation loss: 0.12638857789641686
epoch 16 , train loss: 0.10863285253510793 , validation loss: 0.1264980280715841
epoch 17 , train loss: 0.10854136135241245 , validation loss: 0.1259033198900877
epoch 18 , train loss: 0.1083942376483646 , validation loss: 0.12529181937747194
epoch 19 , train loss: 0.10818875519599298 , validation loss: 0.12489966647098454
epoch 20 , train loss: 0.10802237749802926 , validation loss: 0.12536079384780124
epoch 21 , train loss: 0.10739132065744879 , validation loss: 0.12527294329426214
epoch 22 , train loss: 0.1071129674217174 , validation loss: 0.1255261123075912
epoch 23 , train loss: 0.10687480792884799 , validation loss: 0.1246539429190638
epoch 24 , train loss: 0.10685851277801257 , validation loss: 0.12326716562142637
epoch 25 , train loss: 0.10648814199445254 , validation loss: 0.12357300655406739
epoch 26 , train loss: 0.10593327506408955 , validation loss: 0.1236401299290233
epoch 27 , train loss: 0.10580300723029411 , validation loss: 0.1250277292767665
epoch 28 , train loss: 0.10575001771636595 , validation loss: 0.1226618121942604
epoch 29 , train loss: 0.10567847260246295 , validation loss: 0.12226746679654439
epoch 30 , train loss: 0.10567290852610456 , validation loss: 0.12263409246224835
epoch 31 , train loss: 0.10513444349886106 , validation loss: 0.12242029368068254
epoch 32 , train loss: 0.10502659224980204 , validation loss: 0.12189735371989203
epoch 33 , train loss: 0.10497995914291551 , validation loss: 0.12180449271443726
epoch 34 , train loss: 0.10492426365300078 , validation loss: 0.1218754009640934
epoch 35 , train loss: 0.10488455663152042 , validation loss: 0.12167346348531188
epoch 36 , train loss: 0.10452567750722573 , validation loss: 0.1213753152125135
epoch 37 , train loss: 0.10445636156588152 , validation loss: 0.12161929347020044
epoch 38 , train loss: 0.10447268993350153 , validation loss: 0.12258463470348446
epoch 39 , train loss: 0.1043869368798727 , validation loss: 0.12121965559575167
epoch 40 , train loss: 0.10429973354088302 , validation loss: 0.12130917024195786
epoch 41 , train loss: 0.10398189581313824 , validation loss: 0.12147297220346856
epoch 42 , train loss: 0.10408117779171361 , validation loss: 0.12099152638918963
epoch 43 , train loss: 0.1039385910732111 , validation loss: 0.12078244451759523
epoch 44 , train loss: 0.10394234925121115 , validation loss: 0.12065706554014774
epoch 45 , train loss: 0.10388299821916377 , validation loss: 0.12098881810180266
epoch 46 , train loss: 0.10376427556772101 , validation loss: 0.12067964443370002
epoch 47 , train loss: 0.10368874954931397 , validation loss: 0.12072421838354147
epoch 48 , train loss: 0.1036935117081767 , validation loss: 0.12029554414673656
epoch 49 , train loss: 0.10366479551257132 , validation loss: 0.12066965782610153
epoch 50 , train loss: 0.10359594957170198 , validation loss: 0.12064477638617828
./pretrain_model/pemsbay/model_pemsbay_LGCN_pre4.pt
epoch 1 , train loss: 0.3945027722780761 , validation loss: 0.23031866866614045
epoch 2 , train loss: 0.16851316540586544 , validation loss: 0.1924376239792751
epoch 3 , train loss: 0.15619756387583048 , validation loss: 0.18505703830695094
epoch 4 , train loss: 0.15293834967393327 , validation loss: 0.18972509313438554
epoch 5 , train loss: 0.15049121078162597 , validation loss: 0.17624463721038366
epoch 6 , train loss: 0.14569258660365272 , validation loss: 0.16918004659021724
epoch 7 , train loss: 0.1451786091139463 , validation loss: 0.16987323777077573
epoch 8 , train loss: 0.1439884961232481 , validation loss: 0.16593471830828913
epoch 9 , train loss: 0.14313643626584194 , validation loss: 0.1696058874336128
epoch 10 , train loss: 0.1417633170464728 , validation loss: 0.17163962853446008
epoch 11 , train loss: 0.14064619596249114 , validation loss: 0.1600463225582435
epoch 12 , train loss: 0.13942398304411951 , validation loss: 0.16397142961131245
epoch 13 , train loss: 0.13943706757886068 , validation loss: 0.1608345888340263
epoch 14 , train loss: 0.13833203573043704 , validation loss: 0.16498559334443189
epoch 15 , train loss: 0.13787241315720156 , validation loss: 0.15917419517036507
epoch 16 , train loss: 0.13633542805344698 , validation loss: 0.15775321646630172
epoch 17 , train loss: 0.13615103118478383 , validation loss: 0.1562680253523622
epoch 18 , train loss: 0.13560574278480156 , validation loss: 0.15759887400893144
epoch 19 , train loss: 0.13579297803515022 , validation loss: 0.15573285876393453
epoch 20 , train loss: 0.1355338157175014 , validation loss: 0.1549658377402295
epoch 21 , train loss: 0.13452857196041734 , validation loss: 0.15636854845228643
epoch 22 , train loss: 0.13404883399608727 , validation loss: 0.15605795808674808
epoch 23 , train loss: 0.13392550857804794 , validation loss: 0.1550240555897117
epoch 24 , train loss: 0.1335546621552356 , validation loss: 0.15537802228588327
epoch 25 , train loss: 0.13356395053700917 , validation loss: 0.1544174381195712
epoch 26 , train loss: 0.13278513761290348 , validation loss: 0.15400197259988718
epoch 27 , train loss: 0.13259672199835149 , validation loss: 0.15292838826260252
epoch 28 , train loss: 0.13259238348780775 , validation loss: 0.15351471157218033
epoch 29 , train loss: 0.13238920403539647 , validation loss: 0.15492365614996217
epoch 30 , train loss: 0.13222182561330917 , validation loss: 0.153204327462431
epoch 31 , train loss: 0.13163353887090154 , validation loss: 0.15305525765436984
epoch 32 , train loss: 0.13168019069281411 , validation loss: 0.15348865323019398
epoch 33 , train loss: 0.13156478432110968 , validation loss: 0.15555630109781943
epoch 34 , train loss: 0.13162398314599572 , validation loss: 0.15397088834745698
epoch 35 , train loss: 0.13147110292176 , validation loss: 0.152680891625239
epoch 36 , train loss: 0.13097092320235143 , validation loss: 0.15208233472550628
epoch 37 , train loss: 0.13083391102566813 , validation loss: 0.1528235697043603
epoch 38 , train loss: 0.13091591151937113 , validation loss: 0.15238083534035968
epoch 39 , train loss: 0.13083856211269917 , validation loss: 0.15185463122934992
epoch 40 , train loss: 0.13065919942149695 , validation loss: 0.1520859645023483
epoch 41 , train loss: 0.13037326071564848 , validation loss: 0.15160350080406423
epoch 42 , train loss: 0.1302565858692146 , validation loss: 0.1521941934797288
epoch 43 , train loss: 0.1302920092379756 , validation loss: 0.1518296803632448
epoch 44 , train loss: 0.13021721216970072 , validation loss: 0.15237184998069975
epoch 45 , train loss: 0.13017588848138575 , validation loss: 0.15249112296639708
epoch 46 , train loss: 0.13004203595447797 , validation loss: 0.15224189391165993
epoch 47 , train loss: 0.12999148350444253 , validation loss: 0.15161971915108505
epoch 48 , train loss: 0.129805377819588 , validation loss: 0.15161739906299868
epoch 49 , train loss: 0.12983069646293566 , validation loss: 0.15230434869655537
epoch 50 , train loss: 0.1298560337500821 , validation loss: 0.15125577869660525
./pretrain_model/pemsbay/model_pemsbay_LGCN_pre2.pt
LGraph_pemsbay_15min
test metric: 
MAE: 1.250014201655636 
MAPE: 0.028113067440470457 , RMSE: 2.2731005469085086
./pretrain_model/pemsbay/model_pemsbay_LGCN_pre3.pt
LGraph_pemsbay_15min
test metric: 
MAE: 1.4608928339612965 
MAPE: 0.034514769256672725 , RMSE: 2.7311855448191125
./pretrain_model/pemsbay/model_pemsbay_LGCN_pre4.pt
LGraph_pemsbay_15min
test metric: 
MAE: 1.635084497202494 
MAPE: 0.039608195833162683 , RMSE: 3.106442125768878'''